'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var EventEmitter = require('events');
var old = require('old');
var sublevel = require('sublevelup');
var Blockchain = require('blockchain-spv');

var _require = require('bitcoin-net');

var PeerGroup = _require.PeerGroup;

var _require2 = require('blockchain-download');

var HeaderStream = _require2.HeaderStream;
var BlockStream = _require2.BlockStream;

var Filter = require('bitcoin-filter');
var Inventory = require('bitcoin-inventory');
var pump = require('pump');
var assign = require('object-assign');

function reqd(name) {
  throw new Error('Argument "' + name + '" is required');
}

var Node = function (_EventEmitter) {
  _inherits(Node, _EventEmitter);

  function Node() {
    var params = arguments.length <= 0 || arguments[0] === undefined ? reqd('params') : arguments[0];
    var db = arguments.length <= 1 || arguments[1] === undefined ? reqd('db') : arguments[1];
    var opts = arguments.length <= 2 || arguments[2] === undefined ? {} : arguments[2];

    _classCallCheck(this, Node);

    var _this = _possibleConstructorReturn(this, (Node.__proto__ || Object.getPrototypeOf(Node)).call(this));

    _this.db = sublevel(db);

    _this.params = params;

    _this.chain = Blockchain(params.blockchain, _this.db.sublevel('chain'), opts.chainOpts);
    _this.chain.on('error', _this._error.bind(_this));

    var peerGroupOpts = assign({
      getTip: function getTip() {
        return _this.chain.getTip();
      }
    }, opts.peerGroupOpts);
    var wrtc = opts.wrtc;
    _this.peers = PeerGroup(params.net, assign({ wrtc: wrtc }, peerGroupOpts));
    _this.peers.on('error', _this._error.bind(_this));

    _this.filter = Filter(_this.peers, opts.filterOpts);
    _this.inventory = Inventory(_this.peers);
    return _this;
  }

  _createClass(Node, [{
    key: 'start',
    value: function start() {
      var _this2 = this;

      // connect to peers
      this.peers.connect(function () {
        // wait for filter to be ready
        _this2.filter.onceReady(function () {
          // download headers from peers and pipe into chain
          _this2.headers = HeaderStream(_this2.peers);
          _this2.headers.once('tip', function () {
            var emit = function emit() {
              return _this2.emit('synced', _this2.chain.getTip());
            };
            if (!_this2.headers.lastHash) return emit();
            _this2.chain.once('headers', emit);
          });
          pump(_this2.chain.createLocatorStream(), _this2.headers, _this2.chain.createWriteStream(), _this2._error.bind(_this2));
        });
      });
      return this;
    }
  }, {
    key: 'streamBlocks',
    value: function streamBlocks(from, onBlock) {
      var _this3 = this;

      if (typeof from === 'function') {
        onBlock = from;
        from = null;
      }
      this.chain.onceReady(function () {
        var blocks = BlockStream(_this3.peers, {
          inventory: _this3.inventory,
          filtered: true
        });
        blocks.on('data', onBlock);
        blocks.on('error', _this3._error);
        _this3.chain.createReadStream({ from: from }).pipe(blocks);
      });
      return this;
    }
  }, {
    key: '_error',
    value: function _error(err) {
      if (!err) return;
      this.emit('error', err);
    }
  }]);

  return Node;
}(EventEmitter);

module.exports = old(Node);